local mod = ...


-- Building Asset Processor
mod:registerAssetProcessor("models/TradingPost1.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })
mod:registerAssetProcessor("models/TradingPost2.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })



-- Materials -------------------------------------------------------------------------------------
-- mod:registerAssetId("models/HarborTrade1.fbx/Materials/Material.Plank1", "MATERIAL_TRADINGPOST_PLANK1")



-- Prefab -----------------------------------------------------------------------------------------------------------
mod:registerAssetId("models/TradingPost1.fbx/Prefab/TradingPostPart", "PREFAB_TRADINGPOST")
mod:registerAssetId("models/TradingPost1.fbx/Prefab/ImportPart", "PREFAB_TRADINGPOST_IMPORT")

mod:registerAssetId("models/TradingPost2.fbx/Prefab/DonkeyCart1Part", "PREFAB_TRADINGPOST_DONKEYCART1")
mod:registerAssetId("models/TradingPost2.fbx/Prefab/DonkeyCart2Part", "PREFAB_TRADINGPOST_DONKEYCART2")
mod:registerAssetId("models/TradingPost2.fbx/Prefab/DonkeyCart3Part", "PREFAB_TRADINGPOST_DONKEYCART3")
mod:registerAssetId("models/TradingPost2.fbx/Prefab/DonkeyTrain1Part", "PREFAB_TRADINGPOST_DONKEYTRAIN1")
mod:registerAssetId("models/TradingPost2.fbx/Prefab/DonkeyTrain2Part", "PREFAB_TRADINGPOST_DONKEYTRAIN2")
mod:registerAssetId("models/TradingPost2.fbx/Prefab/DonkeyTrain3Part", "PREFAB_TRADINGPOST_DONKEYTRAIN3")
mod:registerAssetId("models/TradingPost2.fbx/Prefab/OxCartPart", "PREFAB_TRADINGPOST_OXCART")
mod:registerAssetId("models/TradingPost2.fbx/Prefab/DecoOxPart", "PREFAB_TRADINGPOST_DECOOX")
mod:registerAssetId("models/TradingPost2.fbx/Prefab/DecoDonkeyPart", "PREFAB_TRADINGPOST_DECODONKEY")
mod:registerAssetId("models/TradingPost2.fbx/Prefab/DecoOxCartPart", "PREFAB_TRADINGPOST_DECOOXCART")
mod:registerAssetId("models/TradingPost2.fbx/Prefab/DecoDonkeyCartPart", "PREFAB_TRADINGPOST_DECODONKEYCART")



-- Grounding  -------------------------------------------------------------------------------------
mod:registerPrefabComponent("models/TradingPost1.fbx/Prefab/TradingPostPart/Attach_Minor.001", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/TradingPost1.fbx/Prefab/TradingPostPart/Attach_Minor.002", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/TradingPost1.fbx/Prefab/TradingPostPart/Attach_Minor.003", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/TradingPost1.fbx/Prefab/TradingPostPart/Attach_Minor.004", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/TradingPost1.fbx/Prefab/TradingPostPart/Attach_Minor.005", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/TradingPost1.fbx/Prefab/TradingPostPart/Attach_Minor.006", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/TradingPost1.fbx/Prefab/TradingPostPart/Attach_Minor.007", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/TradingPost1.fbx/Prefab/TradingPostPart/Attach_Minor.008", {DataType = "COMP_GROUNDED"})



-- Collider Platform -------------------------------------------------------------------------------------
-- mod:configurePrefabFlagList("models/Ship1.fbx/Prefab/ShipPart1", { "PLATFORM" })



-- Attach Node Type -------------------------------------------------------------------------------------
-- mod:registerPrefabComponent("models/HarborTrade1.fbx/Prefab/GangplankPart", { DataType = "COMP_BUILDING_PART", BuildingPartType = "DOOR" })



-- Smoke Emitter -------------------------------------------------------------------------------------
-- mod:registerPrefabComponent("models/HarborTrade1.fbx/Prefab/HousePart/SmokeEmitter.001", {
-- 	DataType = "COMP_PARTICLE_EMITTER",
-- 	ParticleSystem = "PARTICLE_SYSTEM_HOUSING_SMOKE",
-- 	IsPlaying = true,
-- 	IsEmitting = true
-- })

-- mod:registerPrefabComponent("models/HarborTrade1.fbx/Prefab/HousePart/SmokeEmitter.001", {
-- 	DataType = "COMP_PARTICLE_EMITTER_TOGGLE",
-- 	Enabled = false
-- })



-- Building: Trading Post -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING", 
	Id = "BUILDING_TRADINGPOST",
	Name = "BUILDING_TRADINGPOST_NAME",
	Description = "BUILDING_TRADINGPOST_DESC",
	BuildingType = "MONUMENT",
    AssetCoreBuildingPart = "BUILDING_PART_MONUMENT_POLE",
	BuildingPartSetList = {
		{
			Name = "BUILDING_SET_TRADINGPOST1_NAME",
			BuildingPartList = { 
				"BUILDING_PART_TRADINGPOST",
			}
		},
		{
			Name = "BUILDING_SET_TRADINGPOST2_NAME",
			BuildingPartList = { 
				"BUILDING_PART_TRADINGPOST_DONKEYCART",
				"BUILDING_PART_TRADINGPOST_DONKEYTRAIN",
				"BUILDING_PART_TRADINGPOST_OXCART",
			}
		},
		{
			Name = "BUILDING_SET_TRADINGPOST3_NAME",
			BuildingPartList = { 
				"BUILDING_PART_TRADINGPOST_IMPORTFOOD",
				"BUILDING_PART_TRADINGPOST_IMPORTGOODS",
				"BUILDING_PART_TRADINGPOST_IMPORTMATERIALS",
			}
		},
		{
			Name = "BUILDING_SET_TRADINGPOST4_NAME",
			BuildingPartList = { 
				"BUILDING_PART_TRADINGPOST_DECODONKEY",
				"BUILDING_PART_TRADINGPOST_DECOOX",
				"BUILDING_PART_TRADINGPOST_DECODONKEYCART",
				"BUILDING_PART_TRADINGPOST_DECOOXCART",
			}
		},
    },
	-- RequiredPartList = {
		-- { Category = "CORE", Min = 1, Max = 1 },
		-- { Category = "BUILDING_PART_TYPE_POLE", Min = 1, Max = 1 },
	-- },
	VillagerRequired = { Status = "SERF", Quantity = 12 },
	IsEditable = true
	-- MaterialSetList = {
	-- 	{
	-- 		SetName = "MATERIAL_SET_HARBORTRADE1_NAME",
	-- 		MaterialList = {
	-- 			"MATERIAL_TRADINGPOST_PLANK1",
	-- 			"MATERIAL_TRADINGPOST_TILE1",
	-- 			"MATERIAL_TRADINGPOST_WALL1",
	-- 		}
	-- 	},
	-- 	{
	-- 		SetName = "MATERIAL_SET_HARBORTRADE2_NAME",
	-- 		MaterialList = {
	-- 			"MATERIAL_TRADINGPOST_PLANK2",
	-- 			"MATERIAL_TRADINGPOST_TILE2",
	-- 			"MATERIAL_TRADINGPOST_WALL2",
	-- 		}
	-- 	},
	-- }
})



-- Building Part: Trading Post -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_TRADINGPOST",
	Name = "BUILDING_PART_TRADINGPOST_NAME", 
	Description = "BUILDING_PART_TRADINGPOST_DESC", 
	Category = "CORE",
	Capacity = 50,
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_TRADINGPOST"
	},
	-- ConstructionVisual = "PREFAB_CONSTR_TRADINGPOST",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {11, 11}, {0, 0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } 
			}, 
		}
	},
	AssetBuildingFunction = "BUILDING_FUNCTION_TRADINGPOST_MERCHANT",
	Cost = {
        BuildRightTaxes = {	{ Resource = "GOLD_COINS", Quantity = 50 } },
        UpkeepCost = { { Resource = "GOLD_COINS", Quantity = 25 } },
        RessourcesNeeded = {
            { Resource = "STONE", Quantity = 30 },
		}
	}
})



-- Building Part: Donkey Cart - Random pick of 3 models (Food) -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_TRADINGPOST_DONKEYCART",
	Name = "BUILDING_PART_TRADINGPOST_DONKEYCART_NAME", 
	Description = "BUILDING_PART_TRADINGPOST_DONKEYCART_DESC", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		RandomPartList = {
			"BUILDING_PART_TRADINGPOST_DONKEYCART1",
			"BUILDING_PART_TRADINGPOST_DONKEYCART2",
			"BUILDING_PART_TRADINGPOST_DONKEYCART3",
		}
	},
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {2.0, 4.5}, {0, 0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			}, 
		}
	},
	AssetBuildingFunction = "BUILDING_FUNCTION_ASSIGNABLE_TRADINGPOST_EXPORT_FOOD",
	Cost = {
        BuildRightTaxes = {	{ Resource = "GOLD_COINS", Quantity = 10 } },
        UpkeepCost = { { Resource = "GOLD_COINS", Quantity = 5 } },
        RessourcesNeeded = {
            { Resource = "PLANK", Quantity = 2 },
		}
	}
})



-- Building Part: Donkey Cart 1 (Food) -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_TRADINGPOST_DONKEYCART1",
	Name = "BUILDING_PART_TRADINGPOST_DONKEYCART1_NAME", 
	Description = "BUILDING_PART_TRADINGPOST_DONKEYCART1_DESC", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_TRADINGPOST_DONKEYCART1"
	}
})



-- Building Part: Donkey Cart 2 (Food) -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_TRADINGPOST_DONKEYCART2",
	Name = "BUILDING_PART_TRADINGPOST_DONKEYCART2_NAME", 
	Description = "BUILDING_PART_TRADINGPOST_DONKEYCART2_DESC", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_TRADINGPOST_DONKEYCART2"
	}
})



-- Building Part: Donkey Cart 3 (Food) -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_TRADINGPOST_DONKEYCART3",
	Name = "BUILDING_PART_TRADINGPOST_DONKEYCART3_NAME", 
	Description = "BUILDING_PART_TRADINGPOST_DONKEYCART3_DESC", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_TRADINGPOST_DONKEYCART3"
	}
})



-- Building Part: Donkey Train - Random pick of 3 donkeys (Goods) -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_TRADINGPOST_DONKEYTRAIN",
	Name = "BUILDING_PART_TRADINGPOST_DONKEYTRAIN_NAME", 
	Description = "BUILDING_PART_TRADINGPOST_DONKEYTRAIN_DESC", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		RandomPartList = {
			"BUILDING_PART_TRADINGPOST_DONKEYTRAIN1",
			"BUILDING_PART_TRADINGPOST_DONKEYTRAIN2",
			"BUILDING_PART_TRADINGPOST_DONKEYTRAIN3",
		}
	},
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {1.2, 2.0}, {0, 0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			}, 
		}
	},
	AssetBuildingFunction = "BUILDING_FUNCTION_ASSIGNABLE_TRADINGPOST_EXPORT_GOODS",
	Cost = {
        BuildRightTaxes = {	{ Resource = "GOLD_COINS", Quantity = 10 } },
        UpkeepCost = { { Resource = "GOLD_COINS", Quantity = 5 } },
        RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 1 },
		}
	}
})



-- Building Part: Donkey Train 1 (Goods) -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_TRADINGPOST_DONKEYTRAIN1",
	Name = "BUILDING_PART_TRADINGPOST_DONKEYTRAIN1_NAME", 
	Description = "BUILDING_PART_TRADINGPOST_DONKEYTRAIN1_DESC", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_TRADINGPOST_DONKEYTRAIN1"
	}
})



-- Building Part: Donkey Train 2 (Goods) -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_TRADINGPOST_DONKEYTRAIN2",
	Name = "BUILDING_PART_TRADINGPOST_DONKEYTRAIN2_NAME", 
	Description = "BUILDING_PART_TRADINGPOST_DONKEYTRAIN2_DESC", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_TRADINGPOST_DONKEYTRAIN2"
	}
})



-- Building Part: Donkey Train 3 (Goods) -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_TRADINGPOST_DONKEYTRAIN3",
	Name = "BUILDING_PART_TRADINGPOST_DONKEYTRAIN3_NAME", 
	Description = "BUILDING_PART_TRADINGPOST_DONKEYTRAIN3_DESC", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_TRADINGPOST_DONKEYTRAIN3"
	}
})



-- Building Part: Ox Cart (Materials) -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_TRADINGPOST_OXCART",
	Name = "BUILDING_PART_TRADINGPOST_OXCART_NAME", 
	Description = "BUILDING_PART_TRADINGPOST_OXCART_DESC", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
		CoreRandomBuildingPartList = { "PREFAB_TRADINGPOST_OXCART" },
		MandatoryBuildingPartList = {
			{ BuildingPart = "BUILDING_PART_TRADINGPOST_IMPORTMATERIALS" },
		}
	},
	-- ConstructionVisual = "PREFAB_CONSTR_TRADINGPOST",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {3.0, 7.0}, {0, 0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			}, 
		}
	},
	AssetBuildingFunction = "BUILDING_FUNCTION_ASSIGNABLE_TRADINGPOST_EXPORT_MATERIALS",
	Cost = {
        BuildRightTaxes = {	{ Resource = "GOLD_COINS", Quantity = 20 } },
        UpkeepCost = { { Resource = "GOLD_COINS", Quantity = 10 } },
        RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 1 },
            { Resource = "PLANK", Quantity = 3 },
		}
	}
})



-- Building Part: Donkey (Decorative) -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_TRADINGPOST_DECODONKEY",
	Name = "BUILDING_PART_TRADINGPOST_DECODONKEY_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_TRADINGPOST_DECODONKEY"
	},
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {1.1, 2.2}, {0, 0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			}, 
		}
	},
	Cost = {
        BuildRightTaxes = {	{ Resource = "GOLD_COINS", Quantity = 10 } }
        -- UpkeepCost = { { Resource = "GOLD_COINS", Quantity = 50 } },
        -- RessourcesNeeded = {
        --     { Resource = "STONE", Quantity = 20 },
        --     { Resource = "WOOD", Quantity = 20 },
        --     { Resource = "PLANK", Quantity = 40 },
		-- }
	}
})



-- Building Part: Ox (Decorative) -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_TRADINGPOST_DECOOX",
	Name = "BUILDING_PART_TRADINGPOST_DECOOX_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_TRADINGPOST_DECOOX"
	},
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {1.3, 2.7}, {0, 0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			}, 
		}
	},
	Cost = {
        BuildRightTaxes = {	{ Resource = "GOLD_COINS", Quantity = 10 } }
        -- UpkeepCost = { { Resource = "GOLD_COINS", Quantity = 50 } },
        -- RessourcesNeeded = {
        --     { Resource = "STONE", Quantity = 20 },
        --     { Resource = "WOOD", Quantity = 20 },
        --     { Resource = "PLANK", Quantity = 40 },
		-- }
	}
})



-- Building Part: Ox Cart (Decorative) -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_TRADINGPOST_DECOOXCART",
	Name = "BUILDING_PART_TRADINGPOST_DECOOXCART_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_TRADINGPOST_DECOOXCART"
	},
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {2.7, 3.8}, {0, 0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			}, 
		}
	},
	Cost = {
        -- BuildRightTaxes = {	{ Resource = "GOLD_COINS", Quantity = 100 } },
        -- UpkeepCost = { { Resource = "GOLD_COINS", Quantity = 50 } },
        RessourcesNeeded = {
            { Resource = "PLANK", Quantity = 4 },
		}
	}
})




-- Building Part: Donkey Cart (Decorative) -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_TRADINGPOST_DECODONKEYCART",
	Name = "BUILDING_PART_TRADINGPOST_DECODONKEYCART_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_TRADINGPOST_DECODONKEYCART"
	},
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {1.7, 3.1}, {0, 0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			}, 
		}
	},
	Cost = {
        -- BuildRightTaxes = {	{ Resource = "GOLD_COINS", Quantity = 100 } },
        -- UpkeepCost = { { Resource = "GOLD_COINS", Quantity = 50 } },
        RessourcesNeeded = {
            { Resource = "PLANK", Quantity = 2 },
		}
	}
})



-- Building Part: Food Import - Random pick of 3 -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_TRADINGPOST_IMPORTFOOD",
	Name = "BUILDING_PART_TRADINGPOST_IMPORTFOOD_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		RandomPartList = {
			"MIX1_PART",
			"MIX4_PART",
			"GRAIN_PART",
		}
	},
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {1.2, 2.0}, {0, 0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			}, 
		}
	},
	AssetBuildingFunction = "BUILDING_FUNCTION_ASSIGNABLE_TRADINGPOST_IMPORT_FOOD",
	Cost = {
        -- BuildRightTaxes = {	{ Resource = "GOLD_COINS", Quantity = 100 } },
        -- UpkeepCost = { { Resource = "GOLD_COINS", Quantity = 50 } },
        -- RessourcesNeeded = {
        --     { Resource = "STONE", Quantity = 20 },
        --     { Resource = "WOOD", Quantity = 20 },
        --     { Resource = "PLANK", Quantity = 40 },
			-- }
	}
})



-- Building Part: Goods Import - Random pick of 3 -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_TRADINGPOST_IMPORTGOODS",
	Name = "BUILDING_PART_TRADINGPOST_IMPORTGOODS_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		RandomPartList = {
			"MIX2_PART",
			"MIX5_PART",
			"SPOOLS_PART",
			"PLANKS_PART",
			"BRICKS_PART",
		}
	},
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {1.2, 2.0}, {0, 0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			}, 
		}
	},
	AssetBuildingFunction = "BUILDING_FUNCTION_ASSIGNABLE_TRADINGPOST_IMPORT_GOODS",
	Cost = {
        -- BuildRightTaxes = {	{ Resource = "GOLD_COINS", Quantity = 100 } },
        -- UpkeepCost = { { Resource = "GOLD_COINS", Quantity = 50 } },
        -- RessourcesNeeded = {
        --     { Resource = "STONE", Quantity = 20 },
        --     { Resource = "WOOD", Quantity = 20 },
        --     { Resource = "PLANK", Quantity = 40 },
		-- }
	}
})



-- Building Part: Materials Import - Random pick of 3 -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_TRADINGPOST_IMPORTMATERIALS",
	Name = "BUILDING_PART_TRADINGPOST_IMPORTMATERIALS_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		RandomPartList = {
			"HAY_PART",
			"LOGS_PART",
			"COAL_PART",
			"BARRELS_PART",
			"CRATES_PART",
		}
	},
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {1.2, 2.0}, {0, 0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			}, 
		}
	},
	AssetBuildingFunction = "BUILDING_FUNCTION_ASSIGNABLE_TRADINGPOST_IMPORT_MATERIALS",
	Cost = {
        -- BuildRightTaxes = {	{ Resource = "GOLD_COINS", Quantity = 100 } },
        -- UpkeepCost = { { Resource = "GOLD_COINS", Quantity = 50 } },
        -- RessourcesNeeded = {
        --     { Resource = "STONE", Quantity = 20 },
        --     { Resource = "WOOD", Quantity = 20 },
        --     { Resource = "PLANK", Quantity = 40 },
		-- }
	}
})



-- Resource: Command -------------------------------------------------------------------------------------
mod:register({
	DataType = "RESOURCE",
	Id = "RESOURCE_TRADINGPOST_COMMAND",
	ResourceName = "RESOURCE_TRADINGPOST_COMMAND_NAME",
	Icon = "ICON_COMMAND",
	ResourceTypeList = { "RESOURCE_TYPE_TRADE" },
	IsTradable = false,
    DisplayInInventory = false,
	DisplayInToolbar = false,
	OrderId = 0
})



-- Resource: Import -------------------------------------------------------------------------------------
mod:registerAssetId("icons/Import.png", "ICON_TRADINGPOST_IMPORT")

mod:register({
	DataType = "RESOURCE",
	Id = "RESOURCE_TRADINGPOST_IMPORT",
	ResourceName = "RESOURCE_TRADINGPOST_IMPORT_NAME",
	Icon = "ICON_TRADINGPOST_IMPORT",
	ResourceTypeList = { "RESOURCE_TYPE_TRADE" },
	IsTradable = false,
    DisplayInInventory = false,
	DisplayInToolbar = true,
	OrderId = 0
})



-- Job: Driver -------------------------------------------------------------------------------------
mod:register({
	DataType = "JOB",
	Id = "JOB_TRADINGPOST_DRIVER",
	JobName = "JOB_TRADINGPOST_DRIVER_NAME",
	JobDescription = "JOB_TRADINGPOST_DRIVER_DESC",
	IsLockedByDefault = false,
	DefaultBehavior = "BEHAVIOR_WORK",
	-- UseWorkplaceBehavior = true,
    ProductionDelay = 300.0, -- default 30
	AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
	CharacterSetup = {
		DataType = "CHARACTER_SETUP", 
		-- LeftHandObject = {
		-- 	Model = "PREFAB_TOOL_ENVOY_SCROLL_LONG",
		-- 	WorkAttachName = "Scroll_Anchor", 
		-- 	WalkAttachName = "Scroll_Anchor"
		-- },
        -- FemaleFrontList = {
        --     "PREFAB_ENTERTAINMENT_ACTOR_FEMALE_FRONT",
        -- },
        -- FemaleBeltList = {
        --     "PREFAB_ENTERTAINMENT_ACTOR_FEMALE_BELT",
        -- },
        -- MaleFrontList = {
        --     "PREFAB_ENTERTAINMENT_ACTOR_MALE_FRONT",
        -- },
        -- MaleBeltList = {
        --     "PREFAB_ENTERTAINMENT_ACTOR_MALE_BELT",
        -- },
		WalkAnimation = "WALKING",
		IdleAnimation = "IDLE"
	}
})

mod:override({
    Id = "NEWCOMER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_TRADINGPOST_DRIVER"
    }
})

mod:override({
    Id = "SERF",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_TRADINGPOST_DRIVER"
    }
})



-- Job: Warehouse -------------------------------------------------------------------------------------
mod:register({
	DataType = "JOB",
	Id = "JOB_TRADINGPOST_WAREHOUSE",
	JobName = "JOB_TRADINGPOST_WAREHOUSE_NAME",
	JobDescription = "JOB_TRADINGPOST_WAREHOUSE_DESC",
	IsLockedByDefault = false,
	DefaultBehavior = "BEHAVIOR_WORK",
	-- UseWorkplaceBehavior = true,
    ProductionDelay = 30.0, -- default 30
	AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
	CharacterSetup = {
		DataType = "CHARACTER_SETUP", 
		-- LeftHandObject = {
		-- 	Model = "PREFAB_TOOL_ENVOY_SCROLL_LONG",
		-- 	WorkAttachName = "Scroll_Anchor", 
		-- 	WalkAttachName = "Scroll_Anchor"
		-- },
        -- FemaleFrontList = {
        --     "PREFAB_ENTERTAINMENT_ACTOR_FEMALE_FRONT",
        -- },
        -- FemaleBeltList = {
        --     "PREFAB_ENTERTAINMENT_ACTOR_FEMALE_BELT",
        -- },
        -- MaleFrontList = {
        --     "PREFAB_ENTERTAINMENT_ACTOR_MALE_FRONT",
        -- },
        -- MaleBeltList = {
        --     "PREFAB_ENTERTAINMENT_ACTOR_MALE_BELT",
        -- },
		WalkAnimation = "WALKING",
		IdleAnimation = "IDLE"
	}
})

mod:override({
    Id = "NEWCOMER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_TRADINGPOST_WAREHOUSE"
    }
})

mod:override({
    Id = "SERF",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_TRADINGPOST_WAREHOUSE"
    }
})



-- -- Building Function: Trading Post -------------------------------------------------------------------------------------
-- This code works: envoys will visit the spot. Just decided not to use it
-- _dayRangeMin = 2
-- _dayRangeMax = 2

-- mod:register({
--     DataType = "BUILDING_FUNCTION_POINT_OF_INTEREST",
--     Id = "BUILDING_FUNCTION_TRADINGPOST",
--     Name = "BUILDING_FUNCTION_TRADINGPOST_NAME",
--     VisitorProfileList = {
--         "PROFILE_ENVOY_ROYAL",
--     },
--     DaysBetweenVisit = {_dayRangeMin, _dayRangeMax},
--     VisitorCount = {1, 1},
--     IsNeedLocation = false,
--     TimeAtDestination = 15,
--     VisitorActionWhenLeaving = {
--         DataType = "EVENT_ACTION_PAY",
--         AmountToPay = {
-- 			{
-- 				Resource = "GOLD_COINS",
-- 				Quantity = 1
-- 			},
-- 		}
--     }
-- })



-- -- Building Function: Trading Post -------------------------------------------------------------------------------------
-- -- Tried to make a workplace / warehouse combo. The trader does visit it, but because I cannot create sockets, he doesn't find anything to trade.
-- mod:register({
--     DataType = "BUILDING_FUNCTION_WAREHOUSE",
--     Id = "BUILDING_FUNCTION_TRADINGPOST",
-- 	Name = "BUILDING_FUNCTION_TRADINGPOST_NAME",
-- 	IsPrivate = false,
--     WorkerCapacity = 1,
--     RelatedJob = { 
--         Job = "JOB_TRADINGPOST", 
--         Behavior = "BEHAVIOR_WORK"
-- 	},
-- 	InputInventoryCapacity = {
-- 	},
--     ResourceListNeeded = {
-- 	},
-- 	ResourceProduced = {
-- 		{ Resource = "BV1_EGG", Quantity = 1 },
-- 	},
-- 	AllowedResourceTypeList = {
-- 		"GOLD",
-- 		"RESOURCE",
-- 		"FOOD",
-- 	},
-- 	DefaultResourceVisual = "PREFAB_RESOURCE_VISUAL_CRATE",
-- 	SocketCount = 1,
-- 	SocketCapacity = 50
-- })



-- Building Function: Merchant -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_TRADINGPOST_MERCHANT",
	Name = "BUILDING_FUNCTION_TRADINGPOST_MERCHANT_NAME",
	IsPrivate = false,
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "JOB_HARBORTRADE_MERCHANT", 
        Behavior = "BEHAVIOR_WORK"
	},
	-- HasMaximumInstance = true,
	-- MaximumInstanceAllowed = 2,
	InputInventoryCapacity = {
	},
    ResourceListNeeded = {
	},
	ResourceProduced = {
		{ Resource = "RESOURCE_TRADINGPOST_COMMAND", Quantity = 1 },
	}
})



-- Function: Import/Export -------------------------------------------------------------------------------------
function registerImportExport(_resource, _qty)

	-- Export
	mod:register({
		DataType = "BUILDING_FUNCTION_WORKPLACE",
		Id = "BUILDING_FUNCTION_TRADINGPOST_EXPORT_" .. _resource,
		Name = "BUILDING_FUNCTION_TRADINGPOST_EXPORT_" .. _resource .. "_NAME",
		IsPrivate = false,
		WorkerCapacity = 1,
		RelatedJob = { 
			Job = "JOB_TRADINGPOST_DRIVER", 
			Behavior = "BEHAVIOR_WORK"
		},
		InputInventoryCapacity = {
			{ Resource = "RESOURCE_TRADINGPOST_COMMAND", Quantity = 2 },
			{ Resource = _resource, Quantity = _qty },
		},
		ResourceListNeeded = {
			{ Resource = "RESOURCE_TRADINGPOST_COMMAND", Quantity = 1 },
			{ Resource = _resource, Quantity = _qty },
		},
		ResourceProduced = {
			{ Resource = "RESOURCE_TRADINGPOST_IMPORT", Quantity = 1 },
		}
	})


	-- Import
	mod:register({
		DataType = "BUILDING_FUNCTION_WORKPLACE",
		Id = "BUILDING_FUNCTION_TRADINGPOST_IMPORT_" .. _resource,
		Name = "BUILDING_FUNCTION_TRADINGPOST_IMPORT_" .. _resource .. "_NAME",
		IsPrivate = false,
		WorkerCapacity = 1,
		RelatedJob = { 
			Job = "JOB_TRADINGPOST_WAREHOUSE", 
			Behavior = "BEHAVIOR_WORK"
		},
		InputInventoryCapacity = {
			{ Resource = "RESOURCE_TRADINGPOST_IMPORT", Quantity = 2 },
		},
		ResourceListNeeded = {
			{ Resource = "RESOURCE_TRADINGPOST_IMPORT", Quantity = 1 },
		},
		ResourceProduced = {
			{ Resource = _resource, Quantity = _qty },
		}
	})

end



-- Setup -------------------------------------------------------------------------------------
registerImportExport("RESOURCE_FRUIT", 50)
registerImportExport("WOOD", 50)
registerImportExport("RESOURCE_CANDLE", 50)
registerImportExport("COAL", 25)
registerImportExport("RESOURCE_CIDER", 25)
registerImportExport("BEER", 20)
registerImportExport("CHEESE", 20)
registerImportExport("HONEY", 20)
registerImportExport("CLOTHES", 10)
registerImportExport("WINE", 10)
registerImportExport("RESOURCE_FURNITURE", 10)
registerImportExport("GEMS", 1)
registerImportExport("JEWELRY", 1)
registerImportExport("FLOUR", 100)
registerImportExport("STONE", 100)
registerImportExport("WHEAT", 50)
registerImportExport("WOOL", 50)
registerImportExport("PLANK", 35)
registerImportExport("POLISHED_STONE", 35)
registerImportExport("WOOLEN_CLOTH", 25)
registerImportExport("SPEAR", 20)
registerImportExport("GLASS", 10)
registerImportExport("TOOL", 10)
registerImportExport("SWORD", 5)
registerImportExport("GOLD_BARS", 1)
registerImportExport("BARREL", 10)
registerImportExport("IRON", 7)
registerImportExport("MARBLE", 10)
registerImportExport("RESOURCE_POTTERY", 20)



-- Building Function: Export Food ASSIGNABLE -------------------------------------------------------------------------------------

mod:register({
    DataType = "BUILDING_FUNCTION_ASSIGNABLE",
    Id = "BUILDING_FUNCTION_ASSIGNABLE_TRADINGPOST_EXPORT_FOOD",
    AuthorizedFunctionList = "BUILDING_FUNCTION_LIST_TRADINGPOST_EXPORT_FOOD"
})

mod:register({
    DataType = "BUILDING_FUNCTION_LIST",
    Id = "BUILDING_FUNCTION_LIST_TRADINGPOST_EXPORT_FOOD",
    AssetFunctionList = {
        "BUILDING_FUNCTION_TRADINGPOST_EXPORT_RESOURCE_FRUIT",
        "BUILDING_FUNCTION_TRADINGPOST_EXPORT_CHEESE",
        "BUILDING_FUNCTION_TRADINGPOST_EXPORT_HONEY",
        "BUILDING_FUNCTION_TRADINGPOST_EXPORT_RESOURCE_CIDER",
        "BUILDING_FUNCTION_TRADINGPOST_EXPORT_BEER",
        "BUILDING_FUNCTION_TRADINGPOST_EXPORT_WINE",
        "BUILDING_FUNCTION_TRADINGPOST_EXPORT_WHEAT",
        "BUILDING_FUNCTION_TRADINGPOST_EXPORT_FLOUR",
    }
})



-- Building Function: Export Goods ASSIGNABLE -------------------------------------------------------------------------------------

mod:register({
    DataType = "BUILDING_FUNCTION_ASSIGNABLE",
	Id = "BUILDING_FUNCTION_ASSIGNABLE_TRADINGPOST_EXPORT_GOODS",
    AuthorizedFunctionList = "BUILDING_FUNCTION_LIST_TRADINGPOST_EXPORT_GOODS"
})

mod:register({
    DataType = "BUILDING_FUNCTION_LIST",
    Id = "BUILDING_FUNCTION_LIST_TRADINGPOST_EXPORT_GOODS",
    AssetFunctionList = {
        "BUILDING_FUNCTION_TRADINGPOST_EXPORT_POLISHED_STONE",
        "BUILDING_FUNCTION_TRADINGPOST_EXPORT_RESOURCE_CANDLE",
        "BUILDING_FUNCTION_TRADINGPOST_EXPORT_WOOLEN_CLOTH",
        "BUILDING_FUNCTION_TRADINGPOST_EXPORT_CLOTHES",
        "BUILDING_FUNCTION_TRADINGPOST_EXPORT_PLANK",
        "BUILDING_FUNCTION_TRADINGPOST_EXPORT_RESOURCE_FURNITURE",
        "BUILDING_FUNCTION_TRADINGPOST_EXPORT_RESOURCE_POTTERY",
        "BUILDING_FUNCTION_TRADINGPOST_EXPORT_BARREL",
        "BUILDING_FUNCTION_TRADINGPOST_EXPORT_GLASS",
        "BUILDING_FUNCTION_TRADINGPOST_EXPORT_TOOL",
        "BUILDING_FUNCTION_TRADINGPOST_EXPORT_SWORD",
        "BUILDING_FUNCTION_TRADINGPOST_EXPORT_SPEAR",
        "BUILDING_FUNCTION_TRADINGPOST_EXPORT_JEWELRY",
    }
})



-- Building Function: Export Materials ASSIGNABLE -------------------------------------------------------------------------------------

mod:register({
    DataType = "BUILDING_FUNCTION_ASSIGNABLE",
    Id = "BUILDING_FUNCTION_ASSIGNABLE_TRADINGPOST_EXPORT_MATERIALS",
    AuthorizedFunctionList = "BUILDING_FUNCTION_LIST_TRADINGPOST_EXPORT_MATERIALS"
})

mod:register({
    DataType = "BUILDING_FUNCTION_LIST",
	Id = "BUILDING_FUNCTION_LIST_TRADINGPOST_EXPORT_MATERIALS",
    AssetFunctionList = {
		"BUILDING_FUNCTION_TRADINGPOST_EXPORT_WOOD",
        "BUILDING_FUNCTION_TRADINGPOST_EXPORT_STONE",
        "BUILDING_FUNCTION_TRADINGPOST_EXPORT_WOOL",
        "BUILDING_FUNCTION_TRADINGPOST_EXPORT_COAL",
        "BUILDING_FUNCTION_TRADINGPOST_EXPORT_IRON",
        "BUILDING_FUNCTION_TRADINGPOST_EXPORT_MARBLE",
        "BUILDING_FUNCTION_TRADINGPOST_EXPORT_GOLD_BARS",
        "BUILDING_FUNCTION_TRADINGPOST_EXPORT_GEMS",
    }
})



-- Building Function: Import Food ASSIGNABLE -------------------------------------------------------------------------------------

mod:register({
    DataType = "BUILDING_FUNCTION_ASSIGNABLE",
    Id = "BUILDING_FUNCTION_ASSIGNABLE_TRADINGPOST_IMPORT_FOOD",
    AuthorizedFunctionList = "BUILDING_FUNCTION_LIST_TRADINGPOST_IMPORT_FOOD"
})

mod:register({
    DataType = "BUILDING_FUNCTION_LIST",
    Id = "BUILDING_FUNCTION_LIST_TRADINGPOST_IMPORT_FOOD",
    AssetFunctionList = {
        "BUILDING_FUNCTION_TRADINGPOST_IMPORT_RESOURCE_FRUIT",
        "BUILDING_FUNCTION_TRADINGPOST_IMPORT_CHEESE",
        "BUILDING_FUNCTION_TRADINGPOST_IMPORT_HONEY",
        "BUILDING_FUNCTION_TRADINGPOST_IMPORT_RESOURCE_CIDER",
        "BUILDING_FUNCTION_TRADINGPOST_IMPORT_BEER",
        "BUILDING_FUNCTION_TRADINGPOST_IMPORT_WINE",
        "BUILDING_FUNCTION_TRADINGPOST_IMPORT_WHEAT",
        "BUILDING_FUNCTION_TRADINGPOST_IMPORT_FLOUR",
    }
})



-- Building Function: Import Goods ASSIGNABLE -------------------------------------------------------------------------------------

mod:register({
    DataType = "BUILDING_FUNCTION_ASSIGNABLE",
	Id = "BUILDING_FUNCTION_ASSIGNABLE_TRADINGPOST_IMPORT_GOODS",
    AuthorizedFunctionList = "BUILDING_FUNCTION_LIST_TRADINGPOST_IMPORT_GOODS"
})

mod:register({
    DataType = "BUILDING_FUNCTION_LIST",
    Id = "BUILDING_FUNCTION_LIST_TRADINGPOST_IMPORT_GOODS",
    AssetFunctionList = {
        "BUILDING_FUNCTION_TRADINGPOST_IMPORT_POLISHED_STONE",
        "BUILDING_FUNCTION_TRADINGPOST_IMPORT_RESOURCE_CANDLE",
        "BUILDING_FUNCTION_TRADINGPOST_IMPORT_WOOLEN_CLOTH",
        "BUILDING_FUNCTION_TRADINGPOST_IMPORT_CLOTHES",
        "BUILDING_FUNCTION_TRADINGPOST_IMPORT_PLANK",
        "BUILDING_FUNCTION_TRADINGPOST_IMPORT_RESOURCE_FURNITURE",
        "BUILDING_FUNCTION_TRADINGPOST_IMPORT_RESOURCE_POTTERY",
        "BUILDING_FUNCTION_TRADINGPOST_IMPORT_BARREL",
        "BUILDING_FUNCTION_TRADINGPOST_IMPORT_GLASS",
        "BUILDING_FUNCTION_TRADINGPOST_IMPORT_TOOL",
        "BUILDING_FUNCTION_TRADINGPOST_IMPORT_SWORD",
        "BUILDING_FUNCTION_TRADINGPOST_IMPORT_SPEAR",
        "BUILDING_FUNCTION_TRADINGPOST_IMPORT_JEWELRY",
    }
})



-- Building Function: Import Materials ASSIGNABLE -------------------------------------------------------------------------------------

mod:register({
    DataType = "BUILDING_FUNCTION_ASSIGNABLE",
    Id = "BUILDING_FUNCTION_ASSIGNABLE_TRADINGPOST_IMPORT_MATERIALS",
    AuthorizedFunctionList = "BUILDING_FUNCTION_LIST_TRADINGPOST_IMPORT_MATERIALS"
})

mod:register({
    DataType = "BUILDING_FUNCTION_LIST",
    Id = "BUILDING_FUNCTION_LIST_TRADINGPOST_IMPORT_MATERIALS",
    AssetFunctionList = {
		"BUILDING_FUNCTION_TRADINGPOST_IMPORT_WOOD",
        "BUILDING_FUNCTION_TRADINGPOST_IMPORT_STONE",
        "BUILDING_FUNCTION_TRADINGPOST_IMPORT_WOOL",
        "BUILDING_FUNCTION_TRADINGPOST_IMPORT_COAL",
        "BUILDING_FUNCTION_TRADINGPOST_IMPORT_IRON",
        "BUILDING_FUNCTION_TRADINGPOST_IMPORT_MARBLE",
        "BUILDING_FUNCTION_TRADINGPOST_IMPORT_GOLD_BARS",
        "BUILDING_FUNCTION_TRADINGPOST_IMPORT_GEMS",
    }
})



